Package: org.apache.groovy.contracts.ast.visitor

## [Java] Class AnnotationClosureVisitor

- org.apache.groovy.contracts.ast.visitor.AnnotationClosureVisitor

- All Implemented Interfaces and Traits:
    ASTNodeMetaData

      public class AnnotationClosureVisitor
      extends BaseVisitor
      implements ASTNodeMetaData

  Visits interfaces & classes and looks for `@Requires` or `@Ensures` and creates Closure classes for the annotation closures.

  The annotation closure classes are used later on to check interface contract pre- and post-conditions in implementation classes.

  See Also:
    Requires
    Ensures
    BaseVisitor

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `META_DATA_ORIGINAL_TRY_CATCH_BLOCK` | Metadata key used to stash the original try/catch wrapped assertion block for later phases.
    `static String` | `META_DATA_USE_EXECUTION_TRACKER` | Metadata flag indicating that the rewritten closure performs method calls and therefore needs execution tracking instead of inline expansion.
    `static String` | `OLD_REFERENCES_KEY` | Node metadata key for the set of field names referenced via `old.xxx` in postconditions.

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class BaseVisitor` | `GCONTRACTS_ENABLED_VAR, sourceUnit`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `AnnotationClosureVisitor(SourceUnit sourceUnit, ReaderSource source)` Creates a visitor that rewrites contract annotation closures into generated closure classes.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `visitClass(ClassNode classNode)` Rewrites class-level contract closures and then recurses into inherited types that may also contribute contract annotations.
    `` | `public void` | `visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)` Rewrites method- and constructor-level contract closures into generated closure classes and records auxiliary metadata needed by later transformation phases.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BaseVisitor` | `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`

- - ### Field Detail

    - #### public static final String META_DATA_ORIGINAL_TRY_CATCH_BLOCK

      Metadata key used to stash the original try/catch wrapped assertion block for later phases.

    - #### public static final String META_DATA_USE_EXECUTION_TRACKER

      Metadata flag indicating that the rewritten closure performs method calls and therefore needs execution tracking instead of inline expansion.

    - #### public static final String OLD_REFERENCES_KEY

      Node metadata key for the set of field names referenced via `old.xxx` in postconditions.

  - ### Constructor Detail

    - #### public AnnotationClosureVisitor(SourceUnit sourceUnit, ReaderSource source)

      Creates a visitor that rewrites contract annotation closures into generated closure classes.

      Parameters:
        `sourceUnit` - the source unit currently being transformed
        `source` - the reader source backing the source unit

  - ### Method Detail

    - #### public void visitClass(ClassNode classNode)

      Rewrites class-level contract closures and then recurses into inherited types that may also contribute contract annotations.

      Parameters:
        `classNode` - the class currently being visited

    - #### public void visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)

      Rewrites method- and constructor-level contract closures into generated closure classes and records auxiliary metadata needed by later transformation phases.

      Parameters:
        `methodNode` - the method or constructor being visited
        `isConstructor` - whether the visited executable is a constructor